// This code was autogenerated from db-gateway.service.proto, do not edit.

package io.silentium.go;

import java.util.UUID;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import infrastructure.Utils.Constants;
import infrastructure.domain.UserInfo;
import io.micronaut.http.HttpRequest;
import io.micronaut.http.HttpResponse;
import io.micronaut.http.HttpHeaders;
import silentium.micronaut.nats.annotations.NATSClient;
import io.micronaut.security.annotation.Secured;
import infrastructure.Utils.Constants;
import io.micronaut.security.rules.SecurityRule;
import io.micronaut.http.annotation.Post;
import io.reactivex.Single;
import io.reactivex.Completable;
import java.util.List;
import java.util.Map;
import io.micronaut.http.annotation.Body;
import io.swagger.v3.oas.annotations.media.Schema;

public class   DbGatewayApi {

// Type definitions
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="RequestHeader", description="RequestHeader Description")
    public static class RequestHeader {
			private String userId;
			private String traceId;
			private String careProviderId;
			private boolean auditable;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="CreateRequest", description="CreateRequest Description")
    public static class CreateRequest {
			private UUID transactionId;
			private String databaseName;
			private String collectionName;
			private RequestHeader header;
			private List<byte[]> documents;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="Document", description="Document Description")
    public static class Document {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private List<byte[]> documents;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="CreateResponse", description="CreateResponse Description")
    public static class CreateResponse {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private List<byte[]> documents;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="UpdateRequest", description="UpdateRequest Description")
    public static class UpdateRequest {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private RequestHeader header;
			private List<byte[]> documents;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="UpdateResponse", description="UpdateResponse Description")
    public static class UpdateResponse {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private List<byte[]> documents;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="UpdateManyRequest", description="UpdateManyRequest Description")
    public static class UpdateManyRequest {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private RequestHeader header;
			private byte[] filter;
			private byte[] update;
			private Boolean upsert;
			private Boolean returnModified;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="UpdateManyResponse", description="UpdateManyResponse Description")
    public static class UpdateManyResponse {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private long modifiedCount;
			private List<byte[]> documents;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="FindOneAndReplaceRequest", description="FindOneAndReplaceRequest Description")
    public static class FindOneAndReplaceRequest {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private RequestHeader header;
			private byte[] document;
			private byte[] filter;
			private Boolean upsert;
			private Integer returnNewDocument;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="FindOneAndReplaceResponse", description="FindOneAndReplaceResponse Description")
    public static class FindOneAndReplaceResponse {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private byte[] document;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="FindOneUpdateRequest", description="FindOneUpdateRequest Description")
    public static class FindOneUpdateRequest {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private RequestHeader header;
			private byte[] filter;
			private byte[] update;
			private Boolean upsert;
			private Integer returnNewDocument;
			private byte[] option;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="FindOneUpdateResponse", description="FindOneUpdateResponse Description")
    public static class FindOneUpdateResponse {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private byte[] document;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="ReadRequest", description="ReadRequest Description")
    public static class ReadRequest {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private RequestHeader header;
			private byte[] filter;
			private byte[] projection;
			private byte[] sort;
			private Long skip;
			private Long limit;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="ReadResponse", description="ReadResponse Description")
    public static class ReadResponse {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private List<byte[]> documents;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="FindOneRequest", description="FindOneRequest Description")
    public static class FindOneRequest {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private RequestHeader header;
			private byte[] filter;
			private byte[] projection;
			private byte[] sort;
			private Long skip;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="FindOneResponse", description="FindOneResponse Description")
    public static class FindOneResponse {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private byte[] document;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="AggregateRequest", description="AggregateRequest Description")
    public static class AggregateRequest {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private RequestHeader header;
			private List<byte[]> filters;
			private int batchSize;
			private boolean allowDiskUse;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="AggregateResponse", description="AggregateResponse Description")
    public static class AggregateResponse {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private List<byte[]> documents;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="DeleteRequest", description="DeleteRequest Description")
    public static class DeleteRequest {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private RequestHeader header;
			private byte[] filter;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="DeleteResponse", description="DeleteResponse Description")
    public static class DeleteResponse {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private long deletedCount;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="CountRequest", description="CountRequest Description")
    public static class CountRequest {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private RequestHeader header;
			private byte[] filter;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="CountResponse", description="CountResponse Description")
    public static class CountResponse {
			private String databaseName;
			private String collectionName;
			private long count;
			private UUID transactionId;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="CollectionResponse", description="CollectionResponse Description")
    public static class CollectionResponse {
			private String databaseName;
			private String collectionName;
			private UUID transactionId;
			private List<String> names;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="CollectionRequest", description="CollectionRequest Description")
    public static class CollectionRequest {
			private String databaseName;
			private UUID transactionId;
			private RequestHeader header;
			private String collectionName;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="Transaction", description="Transaction Description")
    public static class Transaction {
			private RequestHeader header;
			private UUID transactionId;
    }
	@Builder(toBuilder = true)
	@Data
	@AllArgsConstructor
	@NoArgsConstructor
    @Schema(name="MultiTenantCollectionCreateRequest", description="MultiTenantCollectionCreateRequest Description")
    public static class MultiTenantCollectionCreateRequest {
			private RequestHeader header;
			private UUID multiTenantId;
    }

// enum definitions

// service definition
    public interface DbGatewayService {
		
		@Post("/create")
		Single<CreateResponse>create(@Body CreateRequest request);
		
		@Post("/update")
		Single<UpdateResponse>update(@Body UpdateRequest request);
		
		@Post("/updateMany")
		Single<UpdateManyResponse>updateMany(@Body UpdateManyRequest request);
		
		@Post("/findOneAndReplace")
		Single<FindOneAndReplaceResponse>findOneAndReplace(@Body FindOneAndReplaceRequest request);
		
		@Post("/findOneAndUpdate")
		Single<FindOneUpdateResponse>findOneAndUpdate(@Body FindOneUpdateRequest request);
		
		@Post("/read")
		Single<ReadResponse>read(@Body ReadRequest request);
		
		@Post("/findOne")
		Single<FindOneResponse>findOne(@Body FindOneRequest request);
		
		@Post("/aggregate")
		Single<AggregateResponse>aggregate(@Body AggregateRequest request);
		
		@Post("/delete")
		Single<DeleteResponse>delete(@Body DeleteRequest request);
		
		@Post("/count")
		Single<CountResponse>count(@Body CountRequest request);
		
		@Post("/collections")
		Single<CollectionResponse>collections(@Body CollectionRequest request);
		
		@Post("/openTransaction")
		Completable openTransaction(@Body Transaction request);
		
		@Post("/abortTransaction")
		Completable abortTransaction(@Body Transaction request);
		
		@Post("/commitTransaction")
		Completable commitTransaction(@Body Transaction request);
		
		@Post("/closeTransaction")
		Completable closeTransaction(@Body Transaction request);
		
		@Post("/createMultiTenantCollections")
		Completable createMultiTenantCollections(@Body MultiTenantCollectionCreateRequest request);
    }
	@NATSClient(id = "api.service.db-gateway", path = "/api/service/db-gateway/db/gateway")
	public interface  DbGatewayServiceClient extends DbGatewayService  {}
}

